#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         C. Radermacher

 Script Function: Datensicherung Homematic und IP-Symcon

#ce ----------------------------------------------------------------------------

;---------------------------------------------------------------------------------------------------------------
; Ab hier die Parameter des Programms eintragen
; Die Erklrungen stehen hinter jedem Parameter
; Verzeichnisse immer in Hochkomma stellen und mit einem Backslash abschlieen
;---------------------------------------------------------------------------------------------------------------

$aSourceBidcos = 'c:\dokumente und einstellungen\all users\Anwendungsdaten\Bidcos-Service\' ;Quellverzeichnis der Bidcos Sicherung
$aSourceIPS = 'c:\IP-Symcon\' ;Quellverzeichnis der IPS Sicherung
$aDestinationBidcos = 'S:\BackupIPS\Bidcos-Service\' ;Zielverzeichnis fr die Bidcos Sicherung
$aDestinationIPS = 'S:\BackupIPS\IP-Symcon\' ;Zielverzeichnis fr die IPS Sicherung

$logdatei = 1 ; Logdatei erstellen 0=nein, 1=ja
$aDestinationLogdatei = "C:\IP-Symcon\logs\" ; Verzeichnis, in dem die Logdateinen zur Sicherung abgelegt werden
$AnzahlSicherungen = 5 ; Anzahl Sicherungen, die aufbewahrt werden, max 50

$id_Bidcos = 51114 ;IPS ID fr Variable zum BidcosDienst. Es sollte eine String-Variable sein
$id_ips = 45453 ;IPS ID fr Variable zum IPS Dienst. E sollte eine String-Variable sein

$Aktion_nach_Sicherung = 1 ;Soll nach der Sicherung ein Skript in IPS gestartet werden 1=ja, 0=nein
$id_ips_script =51333 ;IPS ID fr Skript

;----------------------------------------------------------------------------------------------------------------
;Beginn des Hauptprogramms
; Ab hier keine nderungen mehr!
;----------------------------------------------------------------------------------------------------------------
#include <_multiFileCopy.au3>
#include <_services.au3>
#NoTrayIcon ; Trayicon erstmal verstecken
#include<EditConstants.au3>
#include<StaticConstants.au3>
#include<GUIConstantsEx.au3>
#include<WindowsConstants.au3>

$return = "" ; Variable fr Ergebisse aus Funktionen
$result2 ="" ; Variable fr Rcklieferung aus Funktionen
$aSicherungBidcos = 1 ;Variable fr Sicherung Bidcos, wird bei nicht vorhandenen Verzeichniss auf 0 gesetzt
$aSicherungIPS = 1 ;Variable fr Sicherung IPS, wird bei nicht vorhandenen Verzeichniss auf 0 gesetzt
DIM $afile[50] ;Array fr auslesen der vorhandenen Sicherungen = max 50 Versionen
$msg = "" ;Variable ausgaben in der GUI Box


;----------------------------------------------------------------------------------------------------------------
;Statusfenster vorbereiten
;----------------------------------------------------------------------------------------------------------------
Opt('TrayOnEventMode', 1) ; OnEventMode fr das Traymen
Opt('TrayMenuMode', 1) ; Standard-Traymen entfernen

$sTitle = 'Extended Tooltip'
$BgColor = 0xFFFFDF ; Hintergrundfarbe
$ShColor = 0x666666 ; Schattenfarbe
$Width = 730 ; Breite des Fensters
$Height = 300 ; Hhe des Fensters
$Left = Int(@DesktopWidth/2-$Width/2) ; Horizontale Position (zentriert)
$Top = 2 ; Vertikale Position (zentriert)

$hGui = GUICreate($sTitle, $Width, $Height, $Left, $Top, $WS_POPUPWINDOW, $WS_EX_TOOLWINDOW) ; keine Titelleiste, kein Button in der Taskleiste
GUISetBkColor($BgColor) ; Hintergrundfarbe setzen
GUISetOnEvent($GUI_EVENT_CLOSE, '_End') ; [ESC] beendet das Programm

$hLabel = GUICtrlCreateLabel('', 0, 0, $Width, $Height, Default, $GUI_WS_EX_PARENTDRAG) ; Transparentes Label zum verschieben des Fensters

$hHead = GUICtrlCreateLabel('', 10, 10, $Width-20, 30, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ; Ein Label fr die berschrift
GUICtrlSetFont(-1, 12, 600, 0, 'Arial') ; Gre und Zeichensatz der berschrift setzen

$hText = GUICtrlCreateEdit('', 10, 45, $Width-15, $Height-60, BitOr($WS_VSCROLL, $ES_AUTOVSCROLL, $ES_READONLY), $WS_EX_TRANSPARENT) ; ein scrollbares Editfeld erstellen
GUICtrlSetFont(-1, 10, 400, 0, 'Courier New') ; Gre und Zeichensatz vom Editfeld setzen
GUICtrlSetBkColor(-1, $BgColor) ; Hintergrundfarbe setzen
GUICtrlSetState(-1, $GUI_ONTOP) ; Das Editfeld nach vorne holen, damit man scrollen kann

$hContextMenu = GUICtrlCreateContextMenu($hLabel) ; Kontextmen erstellen
GUICtrlCreateMenuItem('Minimieren', $hContextMenu) ; Minimieren-Eintrag erstellen
GUICtrlSetOnEvent(-1, '_Minimize') ; dem Eintrag eine Funktion zuweisen
GUICtrlCreateMenuItem('Beenden', $hContextMenu) ; Beenden-Eintrag erstellen
GUICtrlSetOnEvent(-1, '_End') ; dem Eintrag eine Funktion zuweisen

TrayCreateItem('Wiederherstellen') ; Traymeneintrag erstellen
TrayItemSetOnEvent(-1, '_Restore') ; dem Eintrag eine Funktion zuweisen
TrayCreateItem('Beenden') ; Traymeneintrag erstellen
TrayItemSetOnEvent(-1, '_End') ; dem Eintrag eine Funktion zuweisen

$hShadow = GUICreate('Shadow', $Width, $Height, $Left+6, $Top+6, $WS_POPUP, BitOR($WS_EX_TOOLWINDOW, $WS_EX_TRANSPARENT)) ; Schattenfenster erzeugen
GUISetBkColor($ShColor) ; Farbe des Schattens setzen
WinSetTrans($hShadow, '', 128) ; Transparenz des Schattens einstellen

GUISetState(@SW_SHOW, $hShadow) ; Schatten anzeigen
GUISetState(@SW_SHOW, $hGui) ; GUI anzeigen
WinSetOnTop($hShadow, '', 1) ; Schatten immer im Vordergrund
WinSetOnTop($sTitle, '', 1) ; GUI immer im Vordergrund

GUIRegisterMsg($WM_MOVE, '_ShadowMove') ; Funktion zum "Schatten verschieben" registrieren

$Head = "IP-Symcon Sicherung vom "&@MDAY&"."&@MON&"."&@YEAR&""
_ausgabe ('INFO  -- Start der Sicherung')



;----------------------------------------------------------------------------------------------------------------
;Prfen der Verzeichnisse
;----------------------------------------------------------------------------------------------------------------
If FileExists($aDestinationLogdatei) Then ; Verzeichnis fr Logdatei vorhanden?
	$logdatei = 1 ; Logdatei kann geschrieben werden
Else
	$logdatei = 0 ; Logdatei kann nicht geschrieben werden
	_ausgabe ('WARN  -- Verzeichnis fr Logdatei existiert nicht')
EndIf

If FileExists($aSourceBidcos) AND FileExists($aDestinationBidcos) Then ; Verzeichnis fr BidcosSicherung vorhanden?
	$aSicherungBidcos = 1 ; Daten knnen gelesen und geschrieben werden
Else
	$aSicherungBidcos = 0 ; Quelle oder Ziel nichtvorhanden
	_ausgabe('ERROR -- Verzeichnisse fr Bidcos-Sicherung existieren nicht')
EndIf

If FileExists($aSourceIPS) AND FileExists($aDestinationIPS) Then ; Verzeichnis fr IPS-Sicherung vorhanden?
	$aSicherungIPS = 1 ; Daten knnen gelesen und geschrieben werden
Else
	$aSicherungIPS = 0 ; Quelle oder Ziel nichtvorhanden
	_ausgabe('ERROR -- Verzeichnisse fr IPS-Sicherung existieren nicht')
EndIf

;----------------------------------------------------------------------------------------------------------------
;Kopie des Bidcos Verzeichnisses
;----------------------------------------------------------------------------------------------------------------
if $aSicherungBidcos = 1 Then
	_ausgabe('INFO  -- Quelldateien BidCos einlesen')
	Global $sSourcePath = $aSourceBidcos ;Bidcos Source zuweisen
	Global $aSource = _MultiFileCopy($sSourcePath) ;Datei als Basis fr das Array der zu kopierenden Dateien erzeugen
	DirCreate ($aDestinationBidcos &@year&"-"&@MON&"-"&@MDAY&"") ; Verzeichnis anlegen
	Global $sDestinationPath = $aDestinationBidcos &@year&"-"&@MON&"-"&@MDAY&"" ; Bidcos Zielverzeichnis zuweisen
	_ausgabe('INFO  -- Datensicherung des Bidcos-Service')
	Global $aDestination = _MultiFileCopy($sSourcePath, $sDestinationPath, True) ;Dateien kopieren
EndIf

;----------------------------------------------------------------------------------------------------------------
;IPS Watchdog stoppen
;----------------------------------------------------------------------------------------------------------------
if $aSicherungIPS = 1 Then
	_ausgabe('INFO  -- IPS Watchdog stoppen')
	WinActivate ("IPSWatchDog Version 2.2.5") ; Watchdog Fenster aktivieren
	Send ("!{F4}") ;Watchdog beenden
EndIf

;----------------------------------------------------------------------------------------------------------------
;IPS Dienst stoppen
;----------------------------------------------------------------------------------------------------------------
if $aSicherungIPS = 1 Then
	_ausgabe('INFO  -- IP-Symcon Dienst stoppen')
	$Service = _Service_Stop("ipsserver") ;IP-Symcon Dienst beenden
	While $return <> "stopped" ; Warten bis der Dienst beendet ist
		$return = _Service_GetState("ipsserver")
	WEnd
EndIf
;----------------------------------------------------------------------------------------------------------------
;Kopie des IPS Verzeichnisses
;----------------------------------------------------------------------------------------------------------------
if $aSicherungIPS = 1 Then
	_ausgabe('INFO  -- Quelldateien IP-Symcon einlesen')
	Global $sSourcePath = $aSourceIPS ;IPS Source zuweisen
	Global $aSource = _MultiFileCopy($sSourcePath) ;Datei als Basis fr das Array der zu kopierenden Dateien erzeugen
	DirCreate ($aDestinationIPS &@year&"-"&@MON&"-"&@MDAY&"") ; Verzeichnis anlegen
	Global $sDestinationPath = $aDestinationIPS &@year&"-"&@MON&"-"&@MDAY&"" ; Simcon Zielverzeichnis zuweisen
	_ausgabe('INFO  -- IP-Symcon Verzeichnis sichern')
	Global $aDestination = _MultiFileCopy($sSourcePath, $sDestinationPath, True) ;Dateien kopieren
EndIf

;----------------------------------------------------------------------------------------------------------------
;IPS Dienst starten
;----------------------------------------------------------------------------------------------------------------
if $aSicherungIPS = 1 Then
	_ausgabe('INFO  -- IP-Symcon Dienst starten')
	$Service = _Service_Start("ipsserver") ;IP-Symcon Dienst starten
	While $return <> "running" ; Warten bis Dienst gestartet ist
		$return = _Service_GetState("ipsserver")
	WEnd
EndIf

;----------------------------------------------------------------------------------------------------------------
;IPSWatchdog starten
;----------------------------------------------------------------------------------------------------------------
if $aSicherungIPS = 1 Then
	_ausgabe('INFO  -- IPS-Watchdog starten')
	Run ("c:\ip-symcon\ipswatchdog.exe", "C:\ip-Symcon\", @SW_HIDE) ;IPSWatchdog starten
EndIf

;----------------------------------------------------------------------------------------------------------------
;Ergebisse in die Variablen von IPS eintragen
;----------------------------------------------------------------------------------------------------------------
_ausgabe('INFO  -- Variablen in IPS aktualisieren')

$TrixiDLL = DllOpen("trixi.dll"); ffnen der trixi.dll
if $TrixiDLL = -1 Then ;Auf Fehler prfen
	_ausgabe('ERROR -- Kann trixi.dll nicht ffnen')
EndIf

DllCall($TrixiDLL, "int", "Connect", "str", "192.168.178.253", "int", 3773) ;mit trixi.dll Server connecten
if @error > 0 Then ;alle Fehler beim Aufrufen dertrixi.dll zusammenfassen
		_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
EndIf

if FileExists ("S:\BackupIPS\Bidcos-Service\"&@YEAR&"-"&@MON&"-"&@MDAY&"\log\bidcos-"&@YEAR&"-"&@MON&"-"&@MDAY&".log") Then ;Wenn Datei vorhanden war Sicherung erfolgreich
	$result2 = DllCall($TrixiDLL, "int", "WriteString", "int", $id_Bidcos, "str", ""&@MDAY&"."&@MON&"."&@YEAR&"-"&@HOUR&":"&@MIN&"");Variable in IPS mit Datum beschreiben
	if @error > 0 Then ;alle Fehler beim Aufrufen dertrixi.dll zusammenfassen
		_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
	EndIf
Else
    $result2 = DllCall($TrixiDLL, "int", "WriteString", "int", $id_Bidcos, "str", "NICHT erfolgreich") ; oder Fehler eintragen
	if @error > 0 Then ;alle Fehler beim Aufrufen der trixi.dll zusammenfassen
		_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
	EndIf
EndIf

If FileExists ("S:\BackupIPS\IP-Symcon\"&@YEAR&"-"&@MON&"-"&@MDAY&"\IPSWatchDog.log") Then ; Prfen, ob Datei existiert
	$return= FileGetTime ("S:\BackupIPS\IP-Symcon\"&@YEAR&"-"&@MON&"-"&@MDAY&"\IPSWatchdog.log" ,0 ,1) ;Datei Datum und Uhrzeit holen
	$return= StringLeft ($return,8);Datum rausfiltern
	$return=StringRight ($return,2);Tag rausfiltern
	if $return = @MDAY Then; Wenn DateiTag gleich aktueller Tag
		$result2 = DllCall($TrixiDLL, "int", "WriteString", "int", $id_ips, "str", ""&@MDAY&"."&@MON&"."&@YEAR&"-"&@HOUR&":"&@MIN&"");Variable in IPS mit Datum beschreiben
		if @error > 0 Then ;alle Fehler beim Aufrufen der trixi.dll zusammenfassen
			_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
		EndIf
	Else
		$result2 = DllCall($TrixiDLL, "int", "WriteString", "int", $id_ips, "str", "NICHT erfolgreich") ;Wenn Dateidatum nicht stimmt Fehler eintragen
		if @error > 0 Then ;alle Fehler beim Aufrufen der trixi.dll zusammenfassen
			_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
		EndIf
	EndIf
Else
    $result2 = DllCall($TrixiDLL, "int", "WriteString", "int", $id_ips, "str", "NICHT erfolgreich") ;Wenn Datei nicht vorhanden Fehler eintragen
	if @error > 0 Then
		_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
	EndIf
EndIf

_ausgabe('INFO  -- Sicherung abgeschlossen')

DllClose($TrixiDLL)

;----------------------------------------------------------------------------------------------------------------
;Sicherungen aufrumen
;----------------------------------------------------------------------------------------------------------------
_ausgabe('INFO  -- Bidcos-Sicherungen aufrumen')

$search = FileFindFirstFile($aDestinationBidcos &"*.*") ;erste Datei suche, hier erstes Verzeichnis, da keine Dateien vorhanden
If $search = -1 Then
	_ausgabe('ERROR -- Bidcos Verzeichnis nicht verfgbar') ;Fehler, Verzeichnis nicht vorhanden
Else
	$i = 0
	While 1 ;In einer Schleife die Anzahl Verzeichnisse zhlen
		$afile[$i] = FileFindNextFile($search)
		If @error Then ExitLoop ;Wenn keine weiteren Verzeichnisse, Schleife beenden
		$i = $i +1
	WEnd

	FileClose($search) ;Searchhandle wieder schlieen

	if $i > $AnzahlSicherungen Then ;Wenn der Zhler grer ist als Anzahl aufzubewahrende Sicherungen
		For $j = 0 to $i-$AnzahlSicherungen ;alle lteren Sicherungen lschen
			$return = DirRemove ($aDestinationBidcos &$afile[$j]&"",1) ;lteste Sicherung lschen
			_ausgabe("INFO  -- Verzeichnis " &$afile[0] &" gelscht")
		Next
	Else
		_ausgabe("INFO  -- Keine alten Sicherungen gelscht") ;Info, wenn keine alten Sicherungen vorhanden
	EndIf
EndIf

_ausgabe('INFO  -- IPS-Sicherungen aufrumen')

$search = FileFindFirstFile($aDestinationIPS&"*.*") ;erste Datei suche, hier erstes Verzeichnis, da keine Dateien vorhanden
If $search = -1 Then
	_ausgabe('ERROR -- IPS Verzeichnis nicht verfgbar') ;Fehler, Verzeichnis nicht vorhanden
Else
	$i = 0
	While 1
		$afile[$i] = FileFindNextFile($search)
		If @error Then ExitLoop
		$i = $i +1
	WEnd

	FileClose($search) ;Searchhandle wieder schlieen

	if $i > $AnzahlSicherungen Then
		For $j = 0 to $i-$AnzahlSicherungen ;alle lteren Sicherungen lschen
			$return = DirRemove ($aDestinationIPS &$afile[0]&"",1) ;Wenn der Zhler grer ist als Anzahl aufzubewahrende Sicherungen
			_ausgabe("INFO  -- Verzeichnis " &$afile[0] &" gelscht") ;lteste Sicherung lschen
		Next
	Else
		_ausgabe("INFO  -- Keine alten Sicherungen gelscht") ;Info, wenn keine alten Sicherungen vorhanden
	EndIf
EndIf

;----------------------------------------------------------------------------------------------------------------
;Script in IPS starten
;----------------------------------------------------------------------------------------------------------------
If $Aktion_nach_Sicherung = 1 Then ;Wenn Skript gestartet werden soll
	$TrixiDLL = DllOpen("trixi.dll"); ffnen der trixi.dll
	if $TrixiDLL = -1 Then ;Auf Fehler prfen
		_ausgabe('ERROR -- Kann trixi.dll nicht ffnen')
	EndIf

	DllCall($TrixiDLL, "int", "Connect", "str", "192.168.178.253", "int", 3773) ;mit trixi.dll Server connecten
	if @error > 0 Then ;alle Fehler beim Aufrufen dertrixi.dll zusammenfassen
		_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
	EndIf

	_ausgabe("INFO  -- Script in IPS starten")

	$result2 = DllCall($TrixiDLL, "int", "RunScript", "int", $id_ips_script) ;Script in IPS starten
		if @error > 0 Then ;alle Fehler beim Aufrufen der trixi.dll zusammenfassen
			_ausgabe('ERROR -- Fehler beim Aufruf der trixi.dll')
		EndIf
EndIf

DllClose($TrixiDLL)

;----------------------------------------------------------------------------------------------------------------
;Logdatei schreiben
;----------------------------------------------------------------------------------------------------------------
If $logdatei = 1 Then ;Wenn Logdatei erstellt werden soll
	$File = FileOpen ($aDestinationLogdatei &@YEAR&"-"&@MON&"-"&@MDAY&"-Sicherung.log",1) ;Datei erstellen
	If $File = -1 Then
		_ausgabe('ERROR -- Kann Logdatei nicht erzeugen') ;Fehlerausgabe auf Bildschirm
		Sleep(10000) ;Wartezeit
	EndIf

	FileWrite($file, $msg) ;Gesamte GUIBox Inhalt in Datei schreiben
	FileClose($file) ;Datei speichern
EndIf

;----------------------------------------------------------------------------------------------------------------
;Funktionen zum Statusfenster
;----------------------------------------------------------------------------------------------------------------
Func _ausgabe ($text) ;Funktion fr die Ausgabe auf dem Bildschirm
	$msg &= ""&@MDAY&"."&@MON&"."&@YEAR&" -- "&@HOUR&":"&@MIN&":"&@SEC&" -- " ;Datum und Uhrzeit voranstellen
	$msg &= $text &@CRLF&'' ;Text aus dem Paramter bernehmen und Zeilenumbruch einfgen
	GUICtrlSetData($hHead, $Head) ; berschrift anzeigen
	GUICtrlSetData($hText, $msg) ; denText anzeigen
EndFunc

Func _End()
    Exit
EndFunc

Func _Minimize()
    GUISetState(@SW_HIDE, $hShadow) ; Schatten verstecken
    GUISetState(@SW_HIDE, $hGui) ; GUI verstecken
    TraySetState(1) ; Trayicon anzeigen
EndFunc

Func _Restore()
    GUISetState(@SW_SHOW, $hShadow) ; Schatten wiederherstellen
    GUISetState(@SW_SHOW, $hGui) ; GUI wiederherstellen
    TraySetState(2) ; Trayicon verstecken
EndFunc

Func _ShadowMove()
    Local $pos = WinGetPos($hGui) ; Fensterposition der GUI holen
    WinMove($hShadow, '', $pos[0]+6, $pos[1]+6) ; das Schatten-Fenster entsprechend verschieben
EndFunc